CHANGES IN VERSION 1.19.20
--------------------------
	o fix bug discovered when the number of features is less than the number of chunks in iterBatch()

CHANGES IN VERSION 1.19.19
--------------------------
	o simple bug fixes to pass R CMD check

CHANGES IN VERSION 1.19.18
--------------------------
	o simplify calcVarPart for lm and lmer.  Add compatibility for glm
	o Simplify checkModelStatus.merMod to allow formula (A|B) where A is continuous
	o remove unused "adjust" arguments for clarity

CHANGES IN VERSION 1.19.17
--------------------------
	o add get_prediction() for results of lm()
	o improve documentation of get_prediction()

CHANGES IN VERSION 1.19.16
--------------------------
	o in canCorPairs() change statistic used to summarize CCA to Cramer's V.  The difference is very subtle, but is now based on first principles.
	o in dream, check that data is a data.frame
	o dream() defaults to computeResiduals=TRUE for compatability with zenith

CHANGES IN VERSION 1.19.14 
--------------------------
	o fix issue with residuals() where examples fail

CHANGES IN VERSION 1.19.13 
--------------------------
	o fix issues with residuals() 
		- https://github.com/GabrielHoffman/variancePartition/issues/18
	o fix issue exporting eBayes, topTable, etc

CHANGES IN VERSION 1.19.12
--------------------------
	o Improve documentation for contrasts in dream.Rmd
	o check that contrasts sum to zero in plotContrasts.

CHANGES IN VERSION 1.19.11
--------------------------
	o in voomWithDreamWeights() fix issue with not defining design
		- https://github.com/GabrielHoffman/variancePartition/issues/17

CHANGES IN VERSION 1.19.10
--------------------------
	o in voomWithDreamWeights() fix issue with returning design matrix	
	o better error if counts can't be converted to matrix
		- https://github.com/GabrielHoffman/variancePartition/issues/15

CHANGES IN VERSION 1.19.7
-------------------------	
	o Round numbers in plotContrasts()
	o fix issues with strings are passed to formula arguments

CHANGES IN VERSION 1.19.6
-------------------------	
	o New gives meaning full error message for dream(), etc when variable is not found in data.

CHANGES IN VERSION 1.19.5
-------------------------	
	o Better error catching when running fitVarPartModel() with fxn that fails
	o add get_prediction() function
		- the following code now can be run in parallel
		fitList = fitVarPartModel( Y, ~ (1|Batch), data, fxn = function(fit){
		           B = variancePartition::get_prediction(fit, ~(1|Batch))
		           fit@resp$y - B
		        }, BPPARAM=SnowParam(3))

CHANGES IN VERSION 1.19.4
-------------------------
	o Update vignette #3, and update documentation of REML argument	

CHANGES IN VERSION 1.19.3
-------------------------
	o add new FAQ.Rmd

CHANGES IN VERSION 1.19.2
-------------------------
	o canCorPairs() now returns NA correlation when two variables have 
		no overlapping observed values
	o plotCorrMatrix() now handles NA correlation values	

CHANGES IN VERSION 1.19.1
-------------------------
	o Bump to next Bioconductor version

CHANGES IN VERSION 1.18.3
-------------------------
	o Improve documentation
	o move location of eBayesFMT code

CHANGES IN VERSION 1.18.2
-------------------------
	o Clean up some code and add documentation
	o document ebayesFMT

CHANGES IN VERSION 1.18.1
-------------------------
	o Clean up some code and add documentation
	o compute effective degrees of freedom for each model

CHANGES IN VERSION 1.18.0
-------------------------
	o Bioconductor freeze

CHANGES IN VERSION 1.17.10
-------------------------
	o fix issue returning residuals from limma

CHANGES IN VERSION 1.17.10
-------------------------
	o resolve issue where dream gives error: r[cbind(1L:p, 1L:p)] <- 1 : subscript out of bounds
		- only occured when no fixed effects were used

CHANGES IN VERSION 1.17.9
-------------------------
	o Fix issues with compatability with R/4.0.0

CHANGES IN VERSION 1.17.8
-------------------------
	o Better error message when response contains missing data

CHANGES IN VERSION 1.17.7
-------------------------
	o Better error message when variable in formula does not exist

CHANGES IN VERSION 1.17.6
-------------------------
	o comply with new Bioconductor check: _R_CHECK_LENGTH_1_LOGIC2_

CHANGES IN VERSION 1.17.5
-------------------------
	o if contrasts for dream() is data.frame, convert to matrix

CHANGES IN VERSION 1.17.4
-------------------------
	o Don't print warnings for residuals() when only one argument passed.
	o fix bug with residuals evaluated with only fixed effects

CHANGES IN VERSION 1.17.3
-------------------------
	o Allow sparseMatrix for gene expression.  Now saves memory by avoiding conversion to matrix.  Processing sparseMatrix will be slower, but memory usage will be low. 
	o dream(..., computeResiduals=TRUE) now computes residuals and allows use of residuals() function

CHANGES IN VERSION 1.17.2
-------------------------
	o fix error in voomWithDreamWeights() when design matrix is null

CHANGES IN VERSION 1.17.1
-------------------------
	o topTable(...,sort.by=) now is correct when and F-test is used
	o fixed issue in classifyTestsF.MArrayLM2, now is much faster

CHANGES IN VERSION 1.15.8
-------------------------
	o Replace cat() with message()
	o add quiet option to a few functions
	o dream() does not call eBayes() when lmFit is used

CHANGES IN VERSION 1.15.7
-------------------------
	o Official release to development branch

CHANGES IN VERSION 1.15.6
-------------------------
	o fix convergence errror when recycling parameters values from first gene
	o add column z.std and F.std to topTable

CHANGES IN VERSION 1.15.4
-------------------------
	o Add error message when scale of fixed effects causes a problem

CHANGES IN VERSION 1.15.3
-------------------------
	o Try changing order of eBayes 

CHANGES IN VERSION 1.15.2
-------------------------
	o Update vignette

CHANGES IN VERSION 1.15.0
-------------------------
	o Push changes to Bioconductor devel

CHANGES IN VERSION 1.13.11
-------------------------
	o Fixed bug in voomWithDreamWeights() with approxfun() with ties

CHANGES IN VERSION 1.13.10
-------------------------
	o fix parallel processing issues

CHANGES IN VERSION 1.13.9
-------------------------
	o update vignette for new parallel processing backend

CHANGES IN VERSION 1.13.8
-------------------------
	o apply empirical Bayes when doing F-test
	o hypothesis testing for single coefficients is now included by default, so only need to specify contrast matrix if for more complicated contrasts  
	o add voomWithDreamWeights() for computing observation weights using random effects
	o Add BiocParallel capability with BPPARAM argument
		- allows parallel processing with lower memory usage
	o dream() is now compatable with gene set enrichments from pinnacle (software comming soon)
	
CHANGES IN VERSION 1.13.7
-------------------------
	o in dream(), add support for genes annotation in DGElist()
	o in dream(), automatically evaluate contrasts for all single coefficients
	o add future compatability for gene set enrichments method "pinnacle"

CHANGES IN VERSION 1.13.5
-------------------------
	o add plotContrasts() to dream vignette

CHANGES IN VERSION 1.13.4
-------------------------
	o export classes to fix bug with class "varPartResults" not being defined
	o Thanks Megan Behringer

CHANGES IN VERSION 1.13.3
-------------------------
	o add plotContrasts()

CHANGES IN VERSION 1.13.2
-------------------------
	o Enable random slope models in dream, but not for estimating variance fractions
	o Thanks Jonas Zierer

CHANGES IN VERSION 1.13.1
-------------------------
	o Add progress bar at ETA
=======
CHANGES IN VERSION 1.12.4
-------------------------
	o Update dream vignette

CHANGES IN VERSION 1.12.3
-------------------------
    o add plotContrasts()
    o Enable random slope models in dream, but not for estimating variance fractions
    o export classes to fix bug with class "varPartResults" not being defined
    	- Thanks Megan Behringer

CHANGES IN VERSION 1.11.13
-------------------------
	o Fix multithreading issue

CHANGES IN VERSION 1.11.11
-------------------------
	o dream can handle multiple contrasts at the same time

CHANGES IN VERSION 1.11.10
-------------------------
	o fix typos in dream vignette
	
CHANGES IN VERSION 1.11.8
-------------------------
	o Check and stop() if response variable has variance of 0
		- in dream(), fitExtractVarPartModel(), and fitVarPartModel() 
	o add standardized_t_stat() implicitly in eBayes() using MArrayLM2 class
		- this transforms moderated t-statistics to have same degrees of freedom

CHANGES IN VERSION 1.11.7
-------------------------
	o Simplify object return by dream to be more more similar to lmFit
		- now returns MArrayLM instead of MArrayLMM_lmer
	o if a fixed effects formula is specified (i.e. not random terms)
		- dream call lmFit in the backend
		- getContrast() works seamlessly
	o dream() now returns gene annotation if passed to function

CHANGES IN VERSION 1.11.6
-------------------------
	o add error checing for L in dream
	o fix typoes in dream vignette
	o fix typoes in theory_practice_random_effects.Rnw

CHANGES IN VERSION 1.11.5 
-------------------------
	o Add dream function for differential expression for repeated measures with a linear mixed model

CHANGES IN VERSION 1.11.2 
-------------------------
	o Add warnings to canCorPairs for colinear terms

CHANGES IN VERSION 1.11.1
-------------------------
	o Add vignette: theory_practice_random_effects.Rnw

CHANGES IN VERSION 1.9.9
-------------------------
	o Fix issue when package is autoloaded when starting R

CHANGES IN VERSION 1.9.8
-------------------------
     o Fix issue where if info data.frame contained a column name "gene", 
     	fitExtractVarPartModel() would not run

CHANGES IN VERSION 1.9.6
-------------------------
        o Fix tximport issue with eval=FALSE

CHANGES IN VERSION 1.9.2
-------------------------
        o Fix vignette

CHANGES IN VERSION 1.9.1
-------------------------
        o Fix formatting of vignette
        o add description of canCorPairs() function

CHANGES IN VERSION 1.5.7
-------------------------
	o include splines in foreach .packages

CHANGES IN VERSION 1.5.6
-------------------------
	o compatibility with tximport v1.3.5


CHANGES IN VERSION 1.5.5
-------------------------
	o Decrease computing time of effective sample size with ESS() by additional ~10x with sparse solver
	o  fix margins for plotPercentBars()
	o Fix bug for getVarianceComponents() when correlated continous variables are included
	o compatibility with ggplot2 2.2.0
		o center plot titles 
		o fix order of bars in plotPercentBars()
		o legend background to transparent
		o set text to be black
	o include lme4 in foreach .packages
	o change residuals color to not be transparent
	o add CITATION information 
	o plotCorrMatrix now shows dendrogram by default 
	o Estimate run time for fitExtractVarPartModel() / fitVarPartModel()
	o improve warnings for plotPercentBar()
	o improve warnings for plotCorrStructure()
	o define ylab for plotVarPart()
	- add as.matrix.varPartResults() (hidden)
	- define isVaryingCoefficientModel() (hidden)	     

CHANGES IN VERSION 1.3.11
-------------------------
	o in canCorPairs() and other functions, convert formula with as.formula()
	o improve error messages for canCorPairs()


CHANGES IN VERSION 1.3.10
-------------------------
	o Add plotStratify()
	o Update documentation

CHANGES IN VERSION 1.3.8
-------------------------
	o Add additional examples to vignette
	o show projected memory usage of fitVarPartModel()

CHANGES IN VERSION 1.3.7
-------------------------
	o fitVarPartModel warns if names in exprObj and data are not identical
	o residuals() and other functions deal with missing values properly

CHANGES IN VERSION 1.3.6
-------------------------
	o Small changes to vignette

CHANGES IN VERSION 1.3.5
-------------------------
	o Fix Bioconductor error

CHANGES IN VERSION 1.3.4
-------------------------
	o Fix typos

CHANGES IN VERSION 1.3.3
-------------------------
	o Improve documentation

CHANGES IN VERSION 1.1.9
-------------------------
	o Update sortCols to handle Measurement.error
	o change backend package structure
	o set Residuals to be grey by default in plotVarPart() and plotPercentBars()
	o add control = lme4::lmerControl(calc.derivs=FALSE, check.rankX="stop.deficient" )
	o add plotCorrStructure

CHANGES IN VERSION 1.1.8
-------------------------
	o Add ESS.R
	o Add fitVarTest.R
	o use lmerTest by default
	o fix bug checkModelStatus() for variables with backticks in name

CHANGES IN VERSION 1.1.7
-------------------------
	o GPL License

CHANGES IN VERSION 1.1.6
-------------------------
	o Move packages from Depends to Imports
	o For clarity, replace = with <- in parts of examples and vignette
	o Stop cluster in examples to solve error on Windows machines

CHANGES IN VERSION 1.1.5
-------------------------
	o Stop cluster in vignette to solve error on Windows machines

CHANGES IN VERSION 1.1.4
-------------------------
	o Fix Bioconductor check error

CHANGES IN VERSION 1.1.3
-------------------------
    o Add details to vignette
	o Fix ggplot2 compatibility issues

CHANGES IN VERSION 1.1.2
-------------------------
	o Add details to vignette

CHANGES IN VERSION 1.1.1
-------------------------
	o add plotPercentBars() to vizualize variance fractions for a subset of genes
	o add ESS() to compute effective sample	size
	o fix x.labels argument in plotStratifyBy().  Previously, this argument was not used correctly

CHANGES IN VERSION 1.0.0
-------------------------
	o Release to Bioconductor 3.2

CHANGES IN VERSION 0.99.9
-------------------------
	o add legend argument to plotStratifyBy()
	o improve warnings / errors for varying coefficient models
	o allow user to manually adjust cutoff for determining when design matrix is singular
	  - changed default cutoff to 0.999 from 0.99

CHANGES IN VERSION 0.99.8
-------------------------
	o improve warnings / errors when design matrix is close to or exactly singular

CHANGES IN VERSION 0.99.7
-------------------------
	o added new class varPartResults to store results of fitExtractVarPartModel() and extractVarPart()
	  - the user will not notice any change, only the backend is different
        o Allow computation of adjusted ICC in addition to ICC.
	o add warning when categorical variables are modeled as fixed effects
	o fix computation of variance fractions for varying coefficient models
	o add getVarianceComponents() to return variances from lmer() or lm() model fit
	o showWarnings=FALSE suppresses warning messages
	o add fxn argument to fitVarPartModel to evaluate any function on the model fit

CHANGES IN VERSION 0.99.6
-------------------------
	o Update DESCRIPTION information

CHANGES IN VERSION 0.99.5
-------------------------
	o residuals deals with missing data gracefully and returns a matrix

CHANGES IN VERSION 0.99.4
-------------------------
       o add documentation for example datasets
       o convert calcVarPart() to S4 from S3 function call
       o fix typos in vignette

CHANGES IN VERSION 0.99.3
-------------------------
       o fitVarPartModel() and fitExractVarPartModel() use S4 instead of S3 calls 

CHANGES IN VERSION 0.99.2
-------------------------
	o rename sort.varParFrac to sortCols
	o support ExpressionSet
	o change options for plotStratifyBy()

# Before Bioconductor submission

CHANGES IN VERSION 0.0.12
-------------------------
	o add plotStratifyBy()
	o update documentation

CHANGES IN VERSION 0.0.11
-------------------------
	o fix sort to work on correct argument

CHANGES IN VERSION 0.0.10
-------------------------
	o fitExtractVarPartModel() and fitVarPartModel() now take subset argument
	o throw warning when no Intercept is specified
	o if using lmer, warning if categorical variable is modeled as fixed effect
	o fixed calcVarPart bug with reporting too few variances for multicategory fixed effects
	o add colinearityScore

CHANGES IN VERSION 0.0.9
-------------------------
    o function now use the precision weights when specified
	o remove warning about unspecified weights, when useWeights=TRUE
	o fix issue with sort with only one variable
	o add main argument to plotVarPart

CHANGES IN VERSION 0.0.8
-------------------------
        o Bug update to vignette and simulated data

CHANGES IN VERSION 0.0.7
-------------------------
	o remove 'variable' from xlab of plotVarPart

CHANGES IN VERSION 0.0.6
-------------------------
	o set REML=FALSE to default.  This fixes issues of inaccurate variance estiamtes, and makes lmer() results more concordant with lm() results
	o Fix residuals function when lm or lmer is used
	o fix useWeights argument error for fitExtractVarPartModel()


CHANGES IN VERSION 0.0.5
-------------------------
        o plotVarPart() as ylim=c(0,100) as default, and can be changed by user
	o fitExtractVarPartModel() labels rows correctly


CHANGES IN VERSION 0.0.4
-------------------------
	o Add sort() for output of extractVarPart() or fitExtractVarPartModel()


CHANGES IN VERSION 0.0.3
-------------------------

	o add residuals function
	o add fitExtractVarPartModel()
	o foreach loops us iterators


CHANGES IN VERSION 0.99.0
-------------------------
	
	o Initial version
